Package: freegroup
Type: Package
Title: The Free Group
Version: 1.2-1-1
Authors@R: c(person(c("Robin", "K. S. "), "Hankin", 
    role=c("aut","cre"),
    email="hankin.robin@gmail.com",
		comment = c(ORCID = "0000-0001-5982-0415")))
Maintainer: Robin K. S. Hankin <hankin.robin@gmail.com>
Description: The free group in R; juxtaposition is represented by a
  plus.  Includes inversion, multiplication by a scalar,
  group-theoretic power operation, and Tietze forms.  To cite the
  package in publications please use Hankin (2022)
  <doi:10.48550/ARXIV.2212.05883>.
Depends: R (>= 4.1.0)
Suggests: knitr, rmarkdown, permutations, testthat, covr
LazyData: yes
Imports: freealg (>= 1.0-4), magic (>= 1.5-9), magrittr, methods, plyr
VignetteBuilder: knitr
License: GPL-2
URL: https://github.com/RobinHankin/freegroup,
        https://robinhankin.github.io/freegroup/
BugReports: https://github.com/RobinHankin/freegroup/issues
RoxygenNote: 7.3.3
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-08-21 18:14:03 UTC; rhankin
Author: Robin K. S. Hankin [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5982-0415>)
Repository: CRAN
Date/Publication: 2026-08-21 21:50:02 UTC

exportPattern("^[[:alpha:]]+")

import("magrittr")
import("methods")

importFrom("magic","shift")
importFrom("plyr","alply")
importFrom("utils", "tail")

importClassesFrom("freealg", "dot")
importMethodsFrom("freealg", "[")

export("%~%")

S3method("%~%", free)

S3method("[", free)
S3method("[<-", free)
S3method("c", free)
S3method("print", free)

S3method("Ops",free)
S3method("rep",free)

S3method("inverse",free)
S3method("inverse",matrix)
S3method("sum" , free)
S3method("cumsum" , free)

S3method("tietze",free)
S3method("tietze",matrix)

S3method("is.id",free)
S3method("is.conjugate",free)

S3method("abs", free)

The free group in R
================

<!-- README.md is generated from README.Rmd. Please edit that file -->

<img src="man/figures/freegroup.png" width = "150" align="right" />

<!-- badges: start -->

[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/freegroup)](https://cran.r-project.org/package=freegroup)
[![Codecov test
coverage](https://app.codecov.io/gh/RobinHankin/freegroup/branch/master/graph/badge.svg)](https://app.codecov.io/gh/RobinHankin/freegroup/branch/master)
<!-- badges: end -->

# Overview

The `freegroup` package provides functionality for working with the free
group in R. A detailed vignette is provided in the package. Informally,
the *free group* is the set
![X](https://latex.codecogs.com/png.latex?X "X") of *words* that are
objects like
![W=c^{-4}bb^2aa^{-1}ca](https://latex.codecogs.com/png.latex?W%3Dc%5E%7B-4%7Dbb%5E2aa%5E%7B-1%7Dca "W=c^{-4}bb^2aa^{-1}ca"),
with a group operation of string juxtaposition. Usually one works only
with words that are in \`\`reduced form’’, which has successive powers
of the same symbol combined, so
![W](https://latex.codecogs.com/png.latex?W "W") would be equal to
![c^{-4}b^3ca](https://latex.codecogs.com/png.latex?c%5E%7B-4%7Db%5E3ca "c^{-4}b^3ca");
see how ![b](https://latex.codecogs.com/png.latex?b "b") appears to the
third power and the ![a](https://latex.codecogs.com/png.latex?a "a")
term in the middle has vanished.

The group operation of juxtaposition is formally indicated by
![\\circ](https://latex.codecogs.com/png.latex?%5Ccirc "\circ"), but
this is often omitted in algebraic notation; thus, for example
![a^2b^{-3}c^2\\circ c^{-2}ba =a^2b^{-3}c^2c{^-2}ba =a^2b^{-2}ba](https://latex.codecogs.com/png.latex?a%5E2b%5E%7B-3%7Dc%5E2%5Ccirc%20c%5E%7B-2%7Dba%20%3Da%5E2b%5E%7B-3%7Dc%5E2c%7B%5E-2%7Dba%20%3Da%5E2b%5E%7B-2%7Dba "a^2b^{-3}c^2\circ c^{-2}ba =a^2b^{-3}c^2c{^-2}ba =a^2b^{-2}ba").

# Installation

You can install the released version of freegroup from
[CRAN](https://CRAN.R-project.org) with:

``` r
# install.packages("freegroup")  # uncomment this to install the package
library("freegroup")
```

# The `freegroup` package in use

Function `rfree()` generates a vector of random free group elements,
giving quick “get you going” examples:

``` r
a <- rfree(10,5)
a
#>  [1] a.d^5.a^-4.b^5.e^-3 a.e^2.b^2           a^3.e^-7.b^-3      
#>  [4] b^7.d^4             a^2.b^-4.c^-4       a^-5.d^3.c^3       
#>  [7] d^-5.e^-1.d^-5.e^3  c.b^-7.c^4.b^-5     c^6.e^2            
#> [10] e^-3.d^5.a^-5
b <- as.free('x')
```

Then we can perform various operations on these vectors:

``` r
a+b
#>  [1] a.d^5.a^-4.b^5.e^-3.x a.e^2.b^2.x           a^3.e^-7.b^-3.x      
#>  [4] b^7.d^4.x             a^2.b^-4.c^-4.x       a^-5.d^3.c^3.x       
#>  [7] d^-5.e^-1.d^-5.e^3.x  c.b^-7.c^4.b^-5.x     c^6.e^2.x            
#> [10] e^-3.d^5.a^-5.x
a-b
#>  [1] a.d^5.a^-4.b^5.e^-3.x^-1 a.e^2.b^2.x^-1           a^3.e^-7.b^-3.x^-1      
#>  [4] b^7.d^4.x^-1             a^2.b^-4.c^-4.x^-1       a^-5.d^3.c^3.x^-1       
#>  [7] d^-5.e^-1.d^-5.e^3.x^-1  c.b^-7.c^4.b^-5.x^-1     c^6.e^2.x^-1            
#> [10] e^-3.d^5.a^-5.x^-1
a^b
#>  [1] x^-1.a.d^5.a^-4.b^5.e^-3.x x^-1.a.e^2.b^2.x          
#>  [3] x^-1.a^3.e^-7.b^-3.x       x^-1.b^7.d^4.x            
#>  [5] x^-1.a^2.b^-4.c^-4.x       x^-1.a^-5.d^3.c^3.x       
#>  [7] x^-1.d^-5.e^-1.d^-5.e^3.x  x^-1.c.b^-7.c^4.b^-5.x    
#>  [9] x^-1.c^6.e^2.x             x^-1.e^-3.d^5.a^-5.x
```

There are a number of package functions that work in a vectorized way:

``` r
sum(a)
#> [1] a.d^5.a^-4.b^5.e^-3.a.e^2.b^2.a^3.e^-7.b^4.d^4.a^2.b^-4.c^-4.a^-5.d^3.c^3.d^-5.e^-1.d^-5.e^3.c.b^-7.c^4.b^-5.c^6.e^-1.d^5.a^-5
```

The package also supports extraction and replacement:

``` r
a[3:9] <- as.free('xy')
a
#>  [1] a.d^5.a^-4.b^5.e^-3 a.e^2.b^2           x.y                
#>  [4] x.y                 x.y                 x.y                
#>  [7] x.y                 x.y                 x.y                
#> [10] e^-3.d^5.a^-5
```

Various simple elements can be created:

``` r
alpha(1:10)
#>  [1] a b c d e f g h i j
abc(1:5)
#> [1] a         a.b       a.b.c     a.b.c.d   a.b.c.d.e
```

# References

-   Wikipedia contributors, “Free group,” *Wikipedia, the free
    encyclopedia*, 4 June 2019.
    \[<https://en.wikipedia.org/w/index.php?title=Free_group&oldid=900295259>\]

# Further information

For more detail, see the package vignette

`vignette("freegroup")`

#' @importFrom magrittr "%>%"
#' @importFrom magrittr "%<>%"
#' @importFrom utils tail
#' @importFrom magic shift
#' @importFrom plyr alply
#' @importFrom methods setOldClass
#' @importClassesFrom freealg dot
#' @importMethodsFrom freealg "["

#' @export
`as.free` <- function(x){  # x is a list
    if(is.free(x)){
      return(x)
    } else if(is.matrix(x)){
        return(free(x))
    } else if(is.character(x)){
        return(char_to_free(x))
    } else if(identical(x,0)|identical(x,0L)){
        return(free(matrix(0,2,0)))
    } else if (is.list(x)){
        return(free(list_to_free(x)))
    } else if(is.vector(x)){    
        return(free(vec_to_matrix(x)))
    } else {
        return(lapply(x,free))
    }
}

#' @export
`is.free` <- function(x){inherits(x,"free")}

#' @export
`free` <- function(x){ # x is a list, each element is a two-row matrix
    if(is.matrix(x)){x <- list(x)}
    stopifnot(all(unlist(lapply(x,is_proper))))
    x <- reduce(x)
    class(x) <- "free"  # This is the *only* place the class is set
    return(x)
}

#' @export
`char_to_matrix` <- function(x){
  if(nchar(x)>0){
      jj <- as.numeric(charToRaw(x))-96
      s <- rep(1,length(jj))
      s[jj<0] <- -1
      jj[jj<0] <- jj[jj<0] + 32
      return(rbind(jj,s))
  } else {   # x=''
      return(matrix(0,2,0))
  }
}

#' @export
`char_to_free` <- function(x){
    jj <- sapply(x,char_to_matrix,simplify=FALSE)
    names(jj) <- names(x)
    return(free(jj))
}

#' @export
`list_to_free` <- function(x){
  stopifnot(is.list(x))
  if(all(unlist(lapply(x,is.matrix)))){
    return(free(x))
  } else if (all(unlist(lapply(x,is.character)))){
    return(free(lapply(x,char_to_matrix)))
  } else if (all(unlist(lapply(x,is.vector)))){
    return(free(lapply(x,vec_to_matrix)))
  } else {
    stop("list_to_free() is confused; it requires a list of matrices or a list of vectors")
  }
}

#' @export
`vec_to_matrix` <- function(x){  # takes a *vector* like c(1,2,-1,-1,2); returns a matrix
    if(all(x==0)){
        return(matrix(NA,2,0))
    } else {
        x <- x[x!=0]
       return(rbind(abs(x),sign(x)))
    }
}

setGeneric("tietze",function(x){standardGeneric("tietze")})

#' @export
`tietze` <- function(x){UseMethod("tietze")}

#' @export
`tietze.matrix` <- function(x){
    c(apply(x,2,function(r){rep(sign(r[2])*r[1],abs(r[2]))}),recursive=TRUE)
}

#' @export
`tietze.free` <- function(x){
  lapply(x,tietze.matrix)
}

#' @export
`print.free` <- function(x, ...){
    if(length(x)==0){
      print(NULL)
    } else {      
      print(noquote(unlist(lapply(x,as.character_free,...))))
    }
    return(invisible(x))
}

#' @export
`as.character_free` <- function(m,latex=getOption("latex")){ # takes a matrix

    symbols <- getOption("freegroup_symbols")
    if(is.null(symbols)){symbols <- letters}
    if(ncol(m)==0){return("0")}
    if(isTRUE(latex)){
        open <- "{"
        close <- "}"
    } else {
        open <- ""
        close <- ""
    }
    f <- function(x){
        ifelse(
            x[2]==1,
            symbols[x[1]],
            paste(symbols[x[1]],"^",open,x[2],close,sep="")
        )
    }
    paste(apply(m,2,f),collapse=".")
}

#' @export
`remove_zero_powers` <- function(a){a[,a[2,,drop=FALSE]!=0,drop=FALSE]}

#' @export
`is_proper` <- function(a){
  return(
      is.matrix(a)     &&
      nrow(a) == 2     &&
      all(a==round(a)) &&
      all(a[1,] > 0)
  )
}

#' @export
`is_reduced` <- function(a){ all(a[2,]!=0) && all(diff(a[1,]) != 0) }
   
`.gsr` <- function(a){  # gsr == Get Start Repeats
    cumsum(rle(a)$lengths)
}

`.gse` <- function(a){   # gse == Get Start & End [of a run]
    cbind(
        1L+length(a)-rev(.gsr(rev(a))),
        .gsr(a)
    )
}

#' @export
`consolidate` <- function(a){
    jj <- .gse(a[1,])
    f <- function(i){sum(a[2,seq(from=jj[i,1],to=jj[i,2])])}
    rbind(
        rle(a[1,])$values,
        sapply(seq_len(nrow(jj)), f)
    )
}

#' @export
`reduce` <- function(a){
    if(is.list(a)){
        return(lapply(a,reduce))
    } else {
        while(!is_reduced(a)){
#            a %<>% consolidate %<>% remove_zero_powers
            a <- remove_zero_powers(consolidate(a))
        }
        return(a)
    }
}

#' @export
`c.free` <- function(...){
    if(!all(unlist(lapply(list(...),is.free)))){
        stop("all arguments must be the same class")
    } else {
        return(free(unlist(list(...),recursive=FALSE)))
    }
}

#' @export
`[.free` <- function(x,...){ free(unclass(x)[...])}

#' @export
`[<-.free` <- function(x, index, value){
    out <- unclass(x)
    out[index] <- value
    return(free(out))
}

#' @export
`rfree` <- function(n=7,size=4,number=size,powers=seq(from=-size,to=size)){
  out <- list()
  for(i in seq_len(n)){
    out[[i]] <- 
      rbind(
          sample(number,size,replace=TRUE),
          sample(powers,size,replace=TRUE)
      )
  }
  return(free(out))
}

#' @export
`rfreee` <- function(n=30, size=8, number=size, powers=seq(from=-size, to=size)){
    rfree(n=n, size=size, number=size, powers=seq(from=-size, to=size))
}

#' @export
`rfreeee` <- function(n=40,size=25, number=size,powers=seq(from=-size, to=size)){
    rfree(n=n, size=size, number=size, powers=seq(from=-size, to=size))
}

#' @export
`abc` <- function(v){
    free(sapply(v,
                function(o){
                    if(o>0){
                        return(rbind(seq_len(o),1))
                    } else if (o==0){
                        return(rbind(1,0))
                    } else {
                        return(rbind(rev(seq_len(-o)),-1))
                    }
                },
                simplify=FALSE))
}

#' @export
`alpha` <- function(v){
    free(sapply(v,
                function(x){
                    if(x!=0){
                        return(rbind(abs(x),sign(x)))
                    } else {
                        return(rbind(1,0))
                    }
                },
                simplify=FALSE))
}

#' @export
`is.id` <- function(x){ UseMethod("is.id",x) }

#' @export
`is.id.free` <- function(x){x==as.free(0)}

#' @export
`id` <- function(n){free(rep(list(matrix(1,2,0)),n))}

`.is_cyc_reduced` <- function(a){  # low-level, works with matrices
  n <- ncol(a)
  if(n>0){
      if(a[1,1] != a[1,n]){
          return(TRUE)
      } else {
          return(prod(a[2,c(1,n)])>0)
      }
  } else { 
      return(TRUE)
  }
}

#' @export
`is.cyclically_reduced` <- function(a){unlist(lapply(unclass(a), .is_cyc_reduced))}
#  a %>% unclass %>% lapply(.is_cyc_reduced) %>% unlist

#' @export
`cyclically_reduce_tietze` <- function(p){  # p is in reduced tietze form
  if(length(unique(p))<2){  # either empty, or only one distinct symbol
    return(p)  
  }
  n <- floor(length(p)/2)
  jj <- (p[seq_len(n)] + p[seq(from=length(p),by= -1, len=n)]) != 0 # zero means cancellable
  if(all(jj)){ # nothing to cancel
    out <- p
  } else if(any(jj)){  # potential cancellations
    i <- min(which(jj))  # there will be i-1 cancellations
    out <- p[seq(from=i,to=length(p)-i+1)]  ## select the middle bit 
  } else {
    ## At this point, all(jj==0); everything from 1-n cancels
    if(length(p)%%2){ # argument p has odd length
     out <- p[n+1]   # return the central element
    } else {  # p has even length
      out <- NULL # return the identity
    }
  }
  return(out)
}

#' @export
`as.cyclically_reduced` <- function(a){
  f <- function(p){ vec_to_matrix(cyclically_reduce_tietze(p))}
  return(free(lapply(tietze(a), f)))
}

#' @export
`cyclically_reduce` <- as.cyclically_reduced

#' @export
`is.conjugate_single` <- function(u,v){

  ## this is a low-level helper function, takes two integer vectors
  ## (words in Tietze form)

  if( (length(u)==0) & (length(v)==0)){return(TRUE)}
  if(length(u) != length(v)){ return(FALSE) }
  ##  at this point, both have identical nonzero length
  out <-
    apply(
        kronecker(t(u),1L+u*0L) ==
        magic::circulant(v,doseq=FALSE), 1,all)
  
  return(any(out))
}

#' @export
"is.conjugate" <- function(x,y){UseMethod("is.conjugate")}

#' @export
`is.conjugate.free` <- function(x,y){  # this is the user-friendly function
  jj <-  cbind(seq_along(x),seq_along(y))
  f <- function(v){
    is.conjugate_single(
        unlist(tietze(as.cyclically_reduced(x[v[1]]))),
        unlist(tietze(as.cyclically_reduced(y[v[2]])))
    )}
  apply(jj,1,f)
}

#' @export
"%~%" <- function(x,y){UseMethod("%~%")}

#' @export
"%~%.free" <- function(x,y){is.conjugate(x,y)}

#' @export
`allconj` <- function(x){
  stopifnot(length(x)==1)
  x <- as.cyclically_reduced(x)
  if(is.id(x)){return(id())}
  out <- free(plyr::alply(magic::circulant(tietze(x)[[1]],doseq=FALSE),1,vec_to_matrix))
  names(out) <- NULL
  return(out)
}

#' @export
`abelianize` <- function(x){
  free(lapply(x,
         function(o){  # takes a 2-row matrix
           jj <- unclass(by(o[2,],o[1,],sum))
           rbind(as.numeric(names(jj)),jj)
         }))
}

#' @export
`is.abelian` <- function(x){x==abelianize(x)}

#' @export
`sum.free` <- function(..., na.rm=FALSE){
  free(do.call("cbind",lapply(unclass(list(...)),function(x){do.call("cbind",x)})))
}

#' @export
`rep.free` <- function(x, ...){
    u <- seq(length.out = length(x))
    return(x[rep(u, ...)])
}

#' @export
`cumsum.free` <- function(x){
    u <- as.free(0)
    out <- rep(u,length(x))
    for(i in seq_along(x)){
        out[i] <- u <- u + x[i]
    }
    return(out)
}

#' @export
`getlet` <- function(x){
  out <- lapply(x,function(m){sort(unique(m[1,]))})
  if(length(out)==1){out <- out[[1]]}
  return(out)
}

#' @export
`keep` <- function(a,yes){
    yes <- getlet(as.free(yes))
#    a %<>% unclass %>% lapply(function(m){m[,(m[1,] %in% yes),drop=FALSE]}) %>% free
    free(lapply(unclass(a),function(m){m[,(m[1,] %in% yes),drop=FALSE]}))
}

#' @export
`discard` <- function(a,no){
    no <- getlet(as.free(no))
    jj <- unique(c(getlet(a),recursive=TRUE))
    keep(a, jj[!jj %in% no])
}

#' @export
`backwards` <- function(x){
    free(lapply(x,function(o){o[,rev(seq_len(ncol(o))),drop=FALSE]}))
  }

#' @export
`subs` <- function(X,...){
    sb <- list(...)
    v <- names(sb)
    out <- X
    for (i in seq_along(sb)) {
        out <- subsu(out, v[i],sb[[i]])
    }
    return(out)
}

#' @export
`subsu` <- function(X,from,to){
  from <- getlet(as.free(from))
  to <- getlet(as.free(to))
  stopifnot(length(to) == 1)
  
  s <- function(M,from,to){
    M[1,M[1,] %in% from] <- to
    return(M)
  }
    
#  a %<>% unclass %>% lapply(s,from=from,to=to) %>% free
  free(lapply(unclass(X),s,from=from,to=to))
}


#' @export
`flip` <- function(X,turn){
  turn <- getlet(as.free(turn))
  
  s <- function(M,turn){
    M[2,M[1,] %in% turn] %<>% "*"(-1)
    return(M)
  }

  X %<>% unclass %>% lapply(s,turn=turn) %>% free
  return(X)  
}

#' @export
`abs.free` <- function(x){
  s <- function(M){
    M[2,] %<>% abs
    return(M)
  }
  x %<>% unclass %>% lapply(s) %>% free
  return(x)
}

#' @export
`size` <- function(a){unlist(lapply(a,ncol))}

#' @export
`total` <- function(a){unlist(lapply(a,function(M){sum(abs(M[2,]))}))}

#' @export
`number` <- function(a){unlist(lapply(a,function(M){length(table(abs(M[1,])))}))}

#' @export
`bigness` <- function(a){
  out <- cbind(size=size(a),total=total(a),number=number(a))
  rownames(out) <- as.character(lapply(a,function(x){as.character_free(x)}))
  return(drop(out))
  }


#' @export
`shift` <- function(x,i=1){magic::shift(x,i)}

setOldClass("free")
setMethod("[", signature(x="dot",i="free",j="ANY"),
          function(x,i,j,drop){
              j <- as.free(j)
              return(-i-j+i+j)
          })


#' @export
`is.power` <- function(d, n){nrow(unique(data.frame(matrix(d, nrow=n, byrow=TRUE)))) == 1}

#' @export
`is.primitive` <- function(x){
    if(is.free(x)){x <- tietze(x)}

    facs  <- x |> lapply(length) |> lapply(function(n){seq_len(n)[n %% seq_len(n) == 0] |> tail(-1)})
    out <- rep(TRUE,length(x))
    for(i in seq_along(x)){
        a <- facs[[i]]
        for(j in a){
            if(is.power(x[[i]],j)){
                out[i] <- FALSE  # the meat
                break()
            }
        }
    }
    return(out)
}

test_that("Test suite aad.R",{

## The following checks verify that various bugs are truly fixed:
expect_silent(as.free('a') * 0)
expect_silent(as.free('a') * (-10:10))
expect_true(all(sapply(0:10,function(n){is.id(alpha(n)+alpha(-n))})))
expect_true(all(sapply(0:10,function(n){is.id(abc(n)+abc(-n))})))

})

test_that("Test suite aae.R",{

    ## The following checks verify that subs() works correctly.
    checker <- function(s){
        expect_true(all(as.free(s) %>% subs(a="z") %>% subs(z="a") == as.free(s)))
        expect_true(all(as.free(s) %>% subs(a="z") == as.free(gsub("a","z",gsub("A","Z",s)))))
    }

    checker(c("","a","aa","aaa","ab","ba","baa","aab"))
    checker(c("","A","aa","aaa","Ab","ba","baa","aab"))
    checker(c("aaaabbaaa","aaacccaababac","cccccca","bbbbb"))
    checker(c("AAAbaaa","aaacccAAAbAbabA","ccccccA","Abbbbb"))
})

## Define some checker functions, and call them at the end.  They
## should all return TRUE if the package works, and stop with error if
## a test is failed.  Function checker1() has one argument, checker2()
## two, and checker3() has three.  These functions also check that the
## vectorization is OK; so for example in checker2(), if 'x' is of
## length 10 and 'y' is of length 1 [e.g. x <- rfree(10,2,2) and y <-
## rfree(10,2,2)], then all three of checker2(x,y), checker2(x,y[1]),
## checker2(x[1],y) should return TRUE.



test_that("Test suite aaa.R",{

checker1 <- function(x,do_expensive_test = TRUE){

  expect_true(is.free(as.free(x)))

  expect_true(all(x==x))
  expect_false(any(x!=x))
  expect_error(!x)
#  expect_error(x*x)
  expect_error(1+x)
  expect_error(x+1)
    
  expect_true(all((x == x + as.free(0))))
  expect_true(all((x == -(-x))))
  expect_true(all((x == +(+x))))

  expect_true(all(x+x-x == x))

  expect_true(all(is.id(x-x)))

  expect_true(all(0*x == as.free(0)))
  expect_true(all(1*x == x))
  expect_true(all(2*x == x+x))
  expect_true(all(3*x == x+x+x))
  expect_true(all(4*x == x+x+x+x))
  expect_true(all(5*x == x+x+x+x+x))
  expect_true(all(6*x == x+x+x+x+x+x))

  expect_true(all(x^x==x))
  expect_true(all(x^id() == x))

  ## verify idempotence of abelianize():
  expect_true(all(abelianize(abelianize(x)) == abelianize(x)))
  expect_true(all(abelianize(abelianize(sum(x))) == abelianize(sum(abelianize(x)))))

  expect_true(all(abelianize(x) == abelianize(backwards(x))))
  expect_true(all(abelianize(x+x) == abelianize(backwards(x)+backwards(x))))
  expect_true(all(abelianize(x+backwards(x)) == abelianize(backwards(x)+x)))

  expect_true(all(abelianize(x*2) == abelianize(backwards(x)*2)))
  expect_true(all(abelianize(x*3) == abelianize(backwards(x)*3)))
  expect_true(all(abelianize(x*4) == abelianize(backwards(x)*4)))
  expect_true(all(abelianize(x*5) == abelianize(backwards(x)*5)))

  expect_true(all(abelianize(x*3) == abelianize(backwards(x) + x + x)))
  expect_true(all(abelianize(x*3) == abelianize(x + backwards(x) + x)))
  expect_true(all(abelianize(x*3) == abelianize(x + x + backwards(x))))
  expect_true(all(abelianize(x*3) == abelianize(backwards(x) + backwards(x) + x)))

  
  expect_true(all(is.id(sum(x,rev(-x)))))
  expect_true(all(is.id(cumsum(c(x,-rev(x)))[2*length(x)])))
  expect_true(all(cumsum(x)[length(x)] == sum(x)))

  allsymbols <- getlet(sum(x))
  if(length(allsymbols)>0){ # guard against identity, always problematic
      a <- allsymbols[1]
      expect_true(all(size(flip(x,a))   == size(x)))
      expect_true(all(total(flip(x,a))  == total(x)))
      expect_true(all(number(flip(x,a)) == number(x)))
  }
  if(length(allsymbols)>=2){ # two or more symbols needed
      b <- allsymbols[2]
      expect_true(all(size(subs(x,a,b))   <= size(x)))
      expect_true(all(total(subs(x,a,b))  <= total(x)))
      expect_true(all(number(subs(x,a,b)) <= number(x)))
  }

  expect_true(all(size(as.cyclically_reduced(x)) <= size(x)))
  expect_true(all(total(as.cyclically_reduced(x)) <= total(x)))
  expect_true(all(number(as.cyclically_reduced(x)) <= number(x)))

  expect_true(all(is.cyclically_reduced(as.cyclically_reduced(x))))

  if(do_expensive_test){
      for(i in seq_along(x)){
          o <- as.cyclically_reduced(x[i])
          expect_true(all(o %~% allconj(o)))
          expect_true(all(all(is.id(allconj(o) + allconj(-o)[shift(rev(1:total(o)))]))))
      }
  }

  expect_output(print(x))
  expect_output(print(x[FALSE]))
  expect_true(is.character(as.character(x)))
    
  return(TRUE)
}


checker2 <- function(x,y){

    expect_true(all(x+y == x*y))
    expect_true(all(y+x == y*x))

    expect_true(all(x^y == -y+x+y))
    expect_true(all(x+y == x-(-y)))

    expect_true(all((x^y)^(-y) == x))

    expect_true(all(abelianize(x) == abelianize(x^y)))
    expect_true(all(abelianize(x+y) == abelianize(y+x)))
    expect_true(all(abelianize(x+y) == abelianize(x+abelianize(y))))

    expect_true(all((x^y)^(-y) == x))

    expect_true(all(abelianize(x+y) == abelianize(abelianize(x)+y)))
  

    expect_true(all(sum(x,y) == sum(sum(x),sum(y))))

    expect_true(all(sum(x^y[1]) == sum(x)^y[1]))


  stopifnot(  size(x+y) <= size(x)   +   size(y))
  stopifnot( total(x+y) <= total(x)  +  total(y))
  stopifnot(number(x+y) <= number(x) + number(y))

  stopifnot(  size(x+y) <= size  (abs(x) + abs(y)))
  stopifnot( total(x+y) <= total (abs(x) + abs(y)))
  stopifnot(number(x+y) <= number(abs(x) + abs(y)))

  stopifnot(is.conjugate(x,x^y))

  return(TRUE)
}

checker3 <- function(x,y,z){
  stopifnot(x+(y+z) == (x+y)+z) # associativity
  stopifnot(x^(y+z) == (x^y)^z) 
  stopifnot(x^z + y^z == (x+y)^z)

  abelianize(x^z - x^y) |> abelianize() |> is.id() |> stopifnot()
  stopifnot(sum(x,y,z) == sum(sum(x),sum(y),sum(z)))

  ## distributivity:
  stopifnot(x * c(y, z) == c(x*y, x*z))
  stopifnot(c(x, y) * z == c(x*z, y*z))

  ## Hall-Witt:
  stopifnot(all(is.id(.[.[x,-y],z]^y + .[.[y,-z],x]^z + .[.[z,-x],y]^x)))
  
  return(TRUE)
}




for(i in 1:2){
    x <- rfree(10,6,3)
    y <- rfree(10,6,3)
    z <- rfree(10,6,3)
    
    checker1(x)
    checker2(x,y)
    checker3(x,y,z)
}

checker1(rfreee(), FALSE)
checker1(rfreeee(), FALSE)

stopifnot(checker1(id()))
stopifnot(checker1(as.free('a')))
stopifnot(checker1(as.free('ab')))

expect_true(is.free(as.free(rbind(c(1,2,1),c(2,1,-1)))))
expect_true(all(as.free(list("a","ab","abc")) == abc(1:3)))
expect_true(all(list_to_free(sapply(1:5,seq_len))==abc(1:5)))
expect_error(list_to_free(list(c,c)))

expect_true(is.free(as.free(unclass(rfree(4,4)))))
expect_error(as.free(function(...){}))
expect_output(print(as.free(0)))
expect_output(print(as.character_free(matrix(1:6,2,3),latex=TRUE)))
expect_error(c(rfree(4,4),rfree(4,4),1))

})

test_that("Test suite aaf.R",{

    ## The following checks verify that is.primitive() and is.power() work correctly.

    
expect_true(all(
    is.primitive(
        as.free(c("a" , "aaaa", "aaaab", "aabaab", "aabcaabcaabcaabc"))) ==
                c(TRUE, FALSE  ,TRUE   , FALSE   , FALSE             )
))


expect_true (is.power(c(7,8,4,7,8,4,7,8,4,7,8,4),4))
expect_false(is.power(c(7,8,4,7,8,4,7,8,4,7,8,5),4))


})

test_that("Test suite aab.R",{

`autosub_checker`  <- function(X,S){ 
    expect_true(all(X == X |> autosub('a',S) |> autosub('a',-S)))
}

## The problem with autosub_checker() is that Nielsen's transformation
## number 4, viz x1 -> x1x2, is a homomorphism but not an isomorphism.

## A discussion is given at https://github.com/RobinHankin/freegroup/issues/42


`permsymb_checker` <- function(X,p){
    expect_true(all(X == X |>
                    permsymb(permutations::as.function.permutation(p)) |>
                    permsymb(permutations::as.function.permutation(permutations::inverse.cycle(p)))
                    ))
}

# randomised tests of permsymb() removed pending
# https://github.com/RobinHankin/permutations/issues/11

for(n in 3:9){
    for(r in 5:6){
#        autosub_checker(X=rfree(n,r), S=discard(rfree(1,r),'a'))
#        permsymb_checker(X=rfree(n,r), p=rperm(n,r))
    }
}

for(i in 1:3){
    permsymb_checker(X=rfree(1,4), p=permutations::as.cycle(permutations::rperm(1,8)))
    permsymb_checker(X=rfree(8,4), p=permutations::as.cycle(permutations::rperm(1,8)))

}


#permsymb_checker(X=rfree(8,4), p=as.cycle(1:9))
expect_warning(autosub(abc(1:6),"c",as.free("xxxyzc")))
expect_silent(autosub(abc(1:6),"c",as.free("")))
})

#' @export
`permsymb_single_X` <- function(X, f){
    stopifnot(length(X) == 1)
    M <- rbind(f(X[[1]][1,,drop=FALSE]))
    p <-  X[[1]][2,,drop=FALSE]
    free(sapply(seq_len(nrow(M)), function(i){rbind(M[i,],p)}, simplify=FALSE))
}

#' @export
`permsymb_single_f` <- function(X, f){
    stopifnot(nrow(with(environment(f), x)) == 1)
    X <- unclass(X)
    for(i in seq_along(X)){
        X[[i]][1,] %<>% f
    }
    return(free(X))
}

#' @export
`permsymb_vec` <- function(X, f){
    M <- with(environment(f), x)
    stopifnot(nrow(M) == length(X))

    for(i in seq_along(X)){
      X[[i]][1,] <- M[i,X[[i]][1,,drop=FALSE], drop=FALSE]
    }
    return(X)
}

#' @export
`permsymb` <- function(X, f){
    if(length(X)==1){
        return(permsymb_single_X(X, f))
    } else if(nrow(with(environment(f), x)) == 1){
        return(permsymb_single_f(X, f))
    } else {
        return(permsymb_vec(X, f))
    }
}

#' @export
`autosub_lowlevel` <- function(M, e, S){  # M is a matrix, e the
                                          # symbol to substitute, S the
                                          # substitutee

    stopifnot(length(e) == 1)
    n <- ncol(S)
    out <- matrix(0L, 2, (n+1)*sum(abs(M[2,M[1,] == e])) + sum(M[1,] != e))

    Splus <- S
    Sminus <- rbind(S[1,],-S[2,])[,n:1]  # negative power
    j <- 1
    for(i in seq_len(ncol(M))){
        if(M[1, i] == e){
          if(M[2, i]>0){
            S <- Splus
            E <- rbind(e, 1L)
          } else {
            S <- Sminus
            E <- rbind(e, -1L)
          }
            r <- abs(M[2, i])

            out[,j:(j+(n+1)*r-1)] <- kronecker(t(rep(1,r)), cbind(E,S))
            j <- j + (n+1)*r
        } else {
            out[,j] <- M[,i]
            j <- j+1
        }
    }
    return(out)
}

#' @export
`autosub` <- function(X, e, S, automorphism_warning=TRUE){
    stopifnot(length(S) == 1)
    S <- S[[1]]
    if(ncol(S) == 0){return(X)}
    if(is.character(e) & length(e) == 1){e <- as.free(e)}
    if(is.free(e)){e <- getlet(e)}
    stopifnot(length(e) == 1)
    if(automorphism_warning){
      if(any(S[1,] == e)){
        warning("substitution not an automorphism")
      }
    }
    for(i in seq_along(X)){
        X[[i]] %<>% autosub_lowlevel(e, S)
    }
    return(free(X))
}

#' @export
"Ops.free" <-
  function (e1, e2 = NULL) 
{
    if(nargs() == 1){  #unary operator
        if (.Generic == "+") {
            return(e1)
        } else if (.Generic == "-") {
            return(inverse(e1))
    } else {
          stop(gettextf("unary operator %s is not implemented", dQuote(.Generic)))
    }
  }

    lclass <- nchar(.Method[1]) > 0
    rclass <- nchar(.Method[2]) > 0
    
    if (lclass && rclass) {
        if (.Generic == "+") {
            return(juxtapose(e1, e2))
        } else if (.Generic == "-"){
            return(juxtapose(e1,inverse(e2)))
        } else if (.Generic == "^"){
            return(free_power(e1,e2))
        } else if (.Generic == "=="){
            return(free_equal(e1,e2))
        } else if (.Generic == "!="){
            return(!free_equal(e1,e2))
        } else if (.Generic == "*"){
            return(juxtapose(e1, e2))
        } else {
            stop(gettextf("<free> %s <free> not defined", .Generic))
        }
    } else if (lclass && !rclass){
      if(.Generic == "*"){
          return(free_repeat(e1,e2))   #e2 should be an integer
      } else {
          stop(gettextf("<free> %s <non-free> not defined", .Generic))
        }
    } else if (!lclass && rclass){
        if(.Generic == "*"){
            return(free_repeat(e2,e1))   #e1 should be an integer
        } else {
            stop(gettextf("<non-free> %s <free> not defined", .Generic))
        }
    } else if (!lclass && !rclass){
        stop("should not reach here")
    } else {
        stop("this cannot happen")
    }
}

#' @export
`inverse` <- function(e1){ UseMethod("inverse",e1) }

#' @export
`inverse.matrix` <- function(e1){ rbind(rev(e1[1,]), -rev(e1[2,])) }

#' @export
`inverse.free` <- function(e1){ free(lapply(e1,inverse)) }

#' @export
`juxtapose`  <- function(e1,e2){  #  vectorized 
    jj <- cbind(seq_along(e1),seq_along(e2))
    out <- list()
    for(i in seq_len(nrow(jj))){
        out[[i]] <- reduce(cbind(e1[[jj[i,1]]],e2[[jj[i,2]]]))
    }
    donames(free(out),e1,e2)
}

#' @export
`free_power` <- function(e1,e2){
    jj <- cbind(seq_along(e1),seq_along(e2))
    out <- list()
    for(i in seq_len(nrow(jj))){
        out[[i]] <- reduce(cbind(
            inverse(e2[[jj[i,2]]]),
            e1[[jj[i,1]]],
            e2[[jj[i,2]]]
                    ))
    }
    donames(free(out),e1,e2)
}

#' @export
`free_equal` <- function(e1,e2){
    stopifnot(is.free(e1),is.free(e2))
    jj <- cbind(seq_along(e1),seq_along(e2))
    out <- 
      apply(jj,1,function(x){
        return(
            all(dim(e1[[x[1]]]) == dim(e2[[x[2]]])) &&
            all(e1[[x[1]]] == e2[[x[2]]])
        )}
        )
    donames(out,e1,e2)
}

#' @export
`free_repeat` <- function(e1,n){ # e1 is free, n an integer; makes vectorized "e1*n" work
    if(identical(as.integer(n),0L)){return(id(length(e1)))}
    jj <- cbind(seq_along(e1),seq_along(n))
    out <- list()
    for(i in seq_len(nrow(jj))){
        M <- e1[[jj[i,1]]]
        nn <- n[jj[i,2]]
        out[[i]] <- 
        if(nn>0){
            M[,rep(seq_len(ncol(M)),nn),drop=FALSE]
        } else if (nn==0){
            M[,FALSE,drop=FALSE]
        } else if (nn<0){
            inverse(M)[,rep(seq_len(ncol(M)),-nn),drop=FALSE]
        }
    }
    return(donames(free(out),e1,n))
}   

#' @export
`donames` <- function(f,e1,e2){
  jj1 <- seq_along(e1)
  jj2 <- seq_along(e2)
  names(jj1) <- names(e1)
  names(jj2) <- names(e2)
  names(f) <- names(jj1+jj2)
  return(f)
}

---
title: "The dot: commutators and the Jacobi identity in the freegroup package"
output: bookdown::html_document2
---

```{r setup,include=FALSE}
set.seed(0)
knitr::opts_chunk$set(echo = TRUE)
library("freegroup")
```

<p style="text-align: right;">
![](`r system.file("help/figures/freegroup.png", package = "freegroup")`){width=10%}
</p>

This short document introduces the dot object and shows how it can be
used to work with commutators and verify the Jacobi identity.  The
prototypical `dot.Rmd` is that of the `freealg` package.  The dot
object is a (trivial) `S4` object of class `dot`:

```{r}
`.` <- new("dot")
```

The point of the dot (!) is that it allows one to calculate the Lie
bracket $[x,y]=x^{-1}y^{-1}xy$ using R idiom `.[x,y]`.  Thus:

```{r}
x <- as.free("x")
y <- as.free("y")
.[x, y]
```

We see that `x` and `y` do not commute (if they did, `.[x,y]` would be
the identity).  It is possible to apply the dot construction `.[x,y]`
to more complicated examples.  Here I show that the Lie bracket is
nonassociative:

```{r checknonassociative}
set.seed(0)
z <- as.free("z")
(LHS <- .[x, .[y, z]])
(RHS <- .[.[x, y], z])
LHS == RHS
``` 

We can have some fun verifying elementary properties.  First, observe
that the abelianization of the commutator is the identity:

```{r checkabelianize}
abelianize(.[x, y])
```

With this definition, the Jacobi identity does not hold:

```{r verifyjacobi}
is.id(.[x, .[y, z]] + .[y, .[z, x]] + .[z, .[x, y]])
```
 
[the Jacobi identity _does_ hold for $[x,y] = xy-yx$, but here we have
$[x,y]=x^{-1}y^{-1}xy$].  However, the Hall-Witt identity does hold:
 
```{r verifyhallwitt}
all(is.id(.[.[x, -y], z]^y + .[.[y, -z], x]^z + .[.[z, -x], y]^x))
``` 

### Package dataset {-}

Following lines create `dot.rda`, residing in the `data/` directory
of the package.

```{r,label=saverowingingdataset}
save(`.`,file="dot.rda")
```

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
\documentclass[nojss]{jss}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% declarations for jss.cls %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% just as usual
\author{Robin K. S. Hankin\\University of Stirling}
\title{The free group in \proglang{R}: introducing the \pkg{freegroup} package}
%\VignetteIndexEntry{The freegroup package}

%% for pretty printing and a nice hypersummary also set:
\Plainauthor{Robin K. S. Hankin}
\Plaintitle{The freegroup package}
\Shorttitle{The freegroup package}

%% an abstract and keywords
\Abstract{
Here I present the {\tt freegroup} package for working with the free
group on a finite set of symbols.  The package is vectorised;
internally it uses an efficient matrix-based representation for free
group objects but uses a configurable print method.  A range of
R-centric functionality is provided.  It is available on CRAN at
\url{https://CRAN.R-project.org/package=freegroup}.  To cite the
\pkg{freegroup} package, use \citet{hankin2022_freegroup}.
}

\Keywords{Free group, Tietze form}
\Plainkeywords{Free group, Tietze form}
  
%% publication information
%% NOTE: This needs to filled out ONLY IF THE PAPER WAS ACCEPTED.
%% If it was not (yet) accepted, leave them commented.
%% \Volume{13}
%% \Issue{9}
%% \Month{September}
%% \Year{2004}
%% \Submitdate{2004-09-29}
%% \Acceptdate{2004-09-29}
%% \Repository{https://github.com/RobinHankin/freegroup} %% this line for Tragula

%% The address of (at least) one author should be given
%% in the following format:
\Address{
  Robin K. S. Hankin\\%\orcid{https://orcid.org/0000-0001-5982-0415}\\
  University of Stirling\\
  E-mail: \email{hankin.robin@gmail.com}
}
%% It is also possible to add a telephone and fax number
%% before the e-mail in the following format:
%% Telephone: +43/1/31336-5053
%% Fax: +43/1/31336-734

%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\SweaveOpts{}
\usepackage{wrapfig}
\usepackage{tikz-cd}
\begin{document}




<<echo=FALSE,print=FALSE>>=
library("freegroup")
options(freegroup_symbols=letters) # should not be necessary
@ 

\section{Introduction}

\setlength{\intextsep}{0pt}
\begin{wrapfigure}{r}{0.2\textwidth}
\begin{center}
\includegraphics[width=1in]{\Sexpr{system.file("help/figures/freegroup.png",package="freegroup")}}
\end{center}
\end{wrapfigure}

The free group is an interesting and
instructive mathematical object with a rich structure that illustrates
many concepts of elementary group theory.  The \pkg{freegroup} package
provides some functionality for manipulating the free group on a
finite list of symbols.  Informally, the {\em free group}
$\left(X,\circ\right)$ on a set $S=\{a,b,c,\ldots,z\}$ is the set $X$
of {\em words} that are objects like $W=c^{-4}bb^2aa^{-1}ca$, with a
group operation of string juxtaposition.  Usually one works only with
words that are in ``reduced form'', which has successive powers of the
same symbol combined, so $W$ would be equal to $c^{-4}b^3ca$; see how
$b$ appears to the third power and the $a$ term in the middle has
vanished.  The group operation of juxtaposition is formally indicated
by $\circ$, but this is often omitted in algebraic notation; thus, for
example $a^2b^{-3}c^2\circ c^{-2}ba =a^2b^{-3}c^2c^{-2}ba
=a^2b^{-2}ba$.

\subsection{Formal definition}

If $X$ is a set, then a group $F$ is called {\em the free group on
$X$} if there is a set map $\Psi\colon X\longrightarrow F$, and for
any group $G$ and set map $\Phi\colon X\longrightarrow G$, there is a
unique homomorphism $\alpha\colon F\longrightarrow G$ such that
$\alpha\circ\Psi=\Phi$, that is, the diagram below commutes:

\begin{tikzcd}
X \arrow[r,"\Psi"] \arrow[dr,"\Phi"]
& F \arrow[d,"\alpha"]\\
& G
\end{tikzcd}

It can be shown that $F$ is unique up to group isomorphism; every
group is a quotient of a free group.

\subsection{Existing work}

Computational support for working with the free group is provided as
part of a number of algebra systems including \cite{GAP4},
Sage~\citep{sagemath2019}, and \proglang{sympy}~\citep{sympy2017}
although in those systems the emphasis is on finitely presented
groups, not in scope for the \pkg{freegroup} package.  There are also
a number of closed-source proprietary systems which are of no value
here.

\section{The package in use}

In the \pkg{freegroup} package, a word is represented by a two-row
integer matrix; the top row is the integer representation of the
symbol and the second row is the corresponding power.  For example, to
represent $a^2b^{-3}ac^2a^{-2}$ we would identify $a$ as 1, $b$ as 2,
etc and write

<<>>=
(M <- rbind(c(1,2,3,3,1),c(2,-3,2,3,-2)))
@

(see how negative entries in the second row correspond to negative
powers).  Then to convert to a more useful form we would have

<<>>=
library("freegroup")
(x <- free(M))
@

The representation for \proglang{R} object \code{x} is still a two-row
matrix, but the print method is active and uses a more visually
appealing scheme.  The default alphabet used is \code{letters}.  We
can coerce strings to free objects:


<<>>=
(y <- as.free("aabbbcccc"))
@

The free group operation is simply juxtaposition, represented here by
the plus symbol:


<<>>=
x + y
@

(see how the $a$ ``cancels out'' in the juxtaposition).

\subsection{Notation}

The package generally uses additive notation but also, as an
experimental feature, supports multipicative notation.  Thus \code{x+y
  == x*y}.  One motivation for the use of ``\code{+}'' rather than
``\code{*}'' is that \proglang{Python} uses ``\code{+}'' for appending
strings:

\begin{verbatim}
>>> "a" + "abc"
'aabc'
>>> 
\end{verbatim}

However, note that the ``\code{+}'' symbol is usually reserved for
commutative and associative operations; string juxtaposition is
associative.  



Multiplication by integers---denoted in \pkg{freegroup}
idiom by ``\code{*}''---is also defined.  Suppose we want to
concatenate 5 copies of \code{x}:

<<>>=
x*5
@

This operation is vectorized:

<<>>=
x*(0:3)
@

There are a few methods for creating free objects, for example:

<<>>=
abc(1:9)
@

And we can also generate random free objects:

<<>>=
rfree(10,4)
@

Inverses are calculated using unary or binary minus:

<<>>=
(p <- rfree(10,4))
-p
p-p
@

We can take the ``sum'' of a vector of free objects simply by
juxtaposing the elements:

<<>>=
sum(p)
@

Powers are defined as per group conjugation: \code{x\string^y ==
y\string^\string{-1\string}xy} (or, written in additive notation,
\code{-y+x+y}):

<<>>=
p
a <- alpha(26)
p^a
@


Thus:

<<>>=
sum(p^a) == sum(p)^a
@

The experimental multiplicative notation allows us to have the
equivalent of $(xy)^z = x^zy^z$ and $x^{(yz)}=(x^y)^z$:

<<>>=
x <- rfree()
y <- rfree()
z <- rfree()
(x*y)^z == x^z * y^z
x^(y*z) == (x^y)^z
@ 

In additive notation these manifest, somewhat unappealingly, as
\code{(x+y)\string^z == x\string^z + y\string^z} and
\code{x\string^(y+z) = (x\string^y)\string^z}.  Further, note that the
distributive law $x*(y+z)=x*y+x*z$ is now incorrect [we have, again
  somewhat unappealingly, $x*(y+z)=x*y*z=x+y+z$] but it can be
resurrected if we reinterpret addition as (vector) juxtaposition:

<<>>=
x * c(y, z) == c(x*y, x*z)
c(x, y) * z == c(x*z, y*z)
@ 


There is also a commutator bracket, defined as $[x,y]=x^{-1}y^{-1}xy$
or in package idiom \code{.[x,y]=-x-y+x+y}:

<<>>=
.[p,a]
@ 

If we have more than 26 symbols the print method runs out of letters:

<<>>=
alpha(1:30)
@

If this is a problem (it might not be: the print method might not be
important) it is possible to override the default symbol set:

<<>>=
options(freegroup_symbols = state.abb)
alpha(1:30)
@

\section{Conclusions and further work}

The \pkg{freegroup} package furnishes a consistent and documented
suite of reasonably efficient \proglang{R}-centric functionality.
Further work might include the finitely presented groups but it is not
clear whether this would be consistent with the precepts of
\proglang{R}.

<<echo=FALSE,print=FALSE>>=
options(freegroup_symbols=letters)
@ 

\bibliography{freegroup}
\end{document}
 

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
\documentclass[nojss]{jss}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% declarations for jss.cls %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% just as usual
\author{Robin K. S. Hankin}
\title{The free group in \proglang{R}: introducing the \pkg{freegroup} package}
%\VignetteIndexEntry{The freegroup package}

%% for pretty printing and a nice hypersummary also set:
\Plainauthor{Robin K. S. Hankin}
\Plaintitle{The freegroup package}
\Shorttitle{The freegroup package}

%% an abstract and keywords
\Abstract{
Here I present the \pkg{freegroup} package for working with the free
group on a finite set of symbols.  The package is vectorised;
internally it uses an efficient matrix-based representation for free
group objects but uses a configurable print method.  A range of
\proglang{R}-centric functionality is provided.  It is available on CRAN at
\url{https://CRAN.R-project.org/package=freegroup}.  To cite the
\pkg{freegroup} package, use \citet{hankin2022_freegroup}.
}

\Keywords{Free group, Tietze form}
\Plainkeywords{Free group, Tietze form}
  
%% publication information
%% NOTE: This needs to filled out ONLY IF THE PAPER WAS ACCEPTED.
%% If it was not (yet) accepted, leave them commented.
\Volume{0}
\Issue{0}
%% \Month{September}
\Year{0000}
\Submitdate{0000-00-00}
\Acceptdate{0000-00-00}
%% \DOI{10.5555/12345678} %% this line for Tragula
%% \Repository{https://github.com/RobinHankin/freegroup} %% this line for Tragula

%% The address of (at least) one author should be given
%% in the following format:
\Address{
  Robin K. S. Hankin\\
  University of Stirling\\
  Scotland\\
  email: \email{hankin.robin@gmail.com}
}
%% It is also possible to add a telephone and fax number
%% before the e-mail in the following format:
%% Telephone: +43/1/31336-5053
%% Fax: +43/1/31336-734

%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\SweaveOpts{}
\usepackage{wrapfig}
\usepackage{tikz-cd}
\begin{document}

\textbf{This document has not been peer-reviewed and is not an
  accepted \textsf{Tragula} publication.  It is intended as an example
  of the style and substance appropriate for submission to
  \textsf{Tragula}.}


<<echo=FALSE,print=FALSE>>=
library("freegroup")
options(freegroup_symbols=letters) # should not be necessary
@ 

\section{Introduction}

\setlength{\intextsep}{0pt}
\begin{wrapfigure}{r}{0.2\textwidth}
\begin{center}
\includegraphics[width=1in]{\Sexpr{system.file("help/figures/freegroup.png",package="freegroup")}}
\end{center}
\end{wrapfigure}

The free group is an interesting and
instructive mathematical object with a rich structure that illustrates
many concepts of elementary group theory.  The \pkg{freegroup} package
provides some functionality for manipulating the free group on a
finite list of symbols.  Informally, the {\em free group}
$\left(X,\circ\right)$ on a set $S=\{a,b,c,\ldots,z\}$ is the set $X$
of {\em words} that are objects like $W=c^{-4}bb^2aa^{-1}ca$, with a
group operation of string juxtaposition.  Usually one works only with
words that are in ``reduced form'', which has successive powers of the
same symbol combined, so $W$ would be equal to $c^{-4}b^3ca$; see how
$b$ appears to the third power and the $a$ term in the middle has
vanished.  The group operation of juxtaposition is formally indicated
by $\circ$, but this is often omitted in algebraic notation; thus, for
example $a^2b^{-3}c^2\circ c^{-2}ba =a^2b^{-3}c^2c^{-2}ba
=a^2b^{-2}ba$.

\subsection{Formal definition}

If $X$ is a set, then a group $F$ is called {\em the free group on
$X$} if there is a set map $\Psi\colon X\longrightarrow F$, and for
any group $G$ and set map $\Phi\colon X\longrightarrow G$, there is a
unique homomorphism $\alpha\colon F\longrightarrow G$ such that
$\alpha\circ\Psi=\Phi$, that is, the diagram below commutes:

\begin{tikzcd}
X \arrow[r,"\Psi"] \arrow[dr,"\Phi"]
& F \arrow[d,"\alpha"]\\
& G
\end{tikzcd}

It can be shown that $F$ is unique up to group isomorphism; every
group is a quotient of a free group.

\subsection{Existing work}

Computational support for working with the free group is provided as
part of a number of algebra systems including \cite{GAP4},
Sage~\citep{sagemath2019}, and \proglang{sympy}~\citep{sympy2017}
although in those systems the emphasis is on finitely presented
groups, not in scope for the \pkg{freegroup} package.  There are also
a number of closed-source proprietary systems which are of no value
here.

\section{The package in use}

In the \pkg{freegroup} package, a word is represented by a two-row
integer matrix; the top row is the integer representation of the
symbol and the second row is the corresponding power.  For example, to
represent $a^2b^{-3}ac^2a^{-2}$ we would identify $a$ as 1, $b$ as 2,
etc and write

<<>>=
(M <- rbind(c(1,2,3,3,1),c(2,-3,2,3,-2)))
@

(see how negative entries in the second row correspond to negative
powers).  Then to convert to a more useful form we would have

<<>>=
library("freegroup")
(x <- free(M))
@

The representation for \proglang{R} object \code{x} is still a two-row
matrix, but the print method is active and uses a more visually
appealing scheme.  The default alphabet used is \code{letters}.  We
can coerce strings to free objects:


<<>>=
(y <- as.free("aabbbcccc"))
@

The free group operation is simply juxtaposition, represented here by
the plus symbol:


<<>>=
x + y
@

(see how the $a$ ``cancels out'' in the juxtaposition).

\subsection{Notation}

The package generally uses additive notation but also, as an
experimental feature, supports multipicative notation.  Thus \code{x+y
  == x*y}.  One motivation for the use of ``\code{+}'' rather than
``\code{*}'' is that \proglang{Python} uses ``\code{+}'' for appending
strings:

\begin{verbatim}
>>> "a" + "abc"
'aabc'
>>> 
\end{verbatim}

However, note that the ``\code{+}'' symbol is usually reserved for
commutative and associative operations; string juxtaposition is
associative.  



Multiplication by integers---denoted in \pkg{freegroup}
idiom by ``\code{*}''---is also defined.  Suppose we want to
concatenate 5 copies of \code{x}:

<<>>=
x*5
@

This operation is vectorized:

<<>>=
x*(0:3)
@

There are a few methods for creating free objects, for example:

<<>>=
abc(1:9)
@

And we can also generate random free objects:

<<>>=
rfree(10,4)
@

Inverses are calculated using unary or binary minus:

<<>>=
(p <- rfree(10,4))
-p
p-p
@

We can take the ``sum'' of a vector of free objects simply by
juxtaposing the elements:

<<>>=
sum(p)
@

Powers are defined as per group conjugation: \code{x\string^y ==
y\string^\string{-1\string}xy} (or, written in additive notation,
\code{-y+x+y}):

<<>>=
p
a <- alpha(26)
p^a
@


Thus:

<<>>=
sum(p^a) == sum(p)^a
@

The experimental multiplicative notation allows us to have the
equivalent of $(xy)^z = x^zy^z$ and $x^{(yz)}=(x^y)^z$:

<<>>=
x <- rfree()
y <- rfree()
z <- rfree()
all((x*y)^z == x^z * y^z)
all(x^(y*z) == (x^y)^z)
@ 

In additive notation these manifest, somewhat unappealingly, as
\code{(x+y)\string^z == x\string^z + y\string^z} and
\code{x\string^(y+z) = (x\string^y)\string^z}.  Further, note that the
distributive law $x*(y+z)=x*y+x*z$ is now incorrect [we have, again
  somewhat unappealingly, $x*(y+z)=x*y*z=x+y+z$] but it can be
resurrected if we reinterpret addition as (vector) juxtaposition:

<<>>=
all(x * c(y, z) == c(x*y, x*z))
all(c(x, y) * z == c(x*z, y*z))
@ 


There is also a commutator bracket, defined as $[x,y]=x^{-1}y^{-1}xy$
or in package idiom \code{.[x,y] = -x-y+x+y}:

<<>>=
.[p,a]
@ 

If we have more than 26 symbols the print method runs out of letters:

<<>>=
alpha(1:30)
@

If this is a problem (it might not be: the print method might not be
important) it is possible to override the default symbol set:

<<>>=
options(freegroup_symbols = state.abb)
alpha(1:30)
@

\section{Conclusions and further work}

The \pkg{freegroup} package furnishes a consistent and documented
suite of reasonably efficient \proglang{R}-centric functionality.
Further work might include the finitely presented groups but it is not
clear whether this would be consistent with the precepts of
\proglang{R}.

<<echo=FALSE,print=FALSE>>=
options(freegroup_symbols=letters)
@ 

\bibliography{freegroup}
\end{document}
 

\name{Extract}
\alias{Extract.free}
\alias{[.free}
\alias{[<-.free}
\title{Extract or replace parts of a free group object}
\description{Extract or replace subsets of free objects}
\usage{
\method{[}{free}(x, ...)
\method{[}{free}(x, index) <-  value
}
\arguments{
  \item{x}{Object of class \code{free}}
  \item{index}{elements to extract or replace}
  \item{value}{replacement value}
  \item{...}{Elements to extract}
}
\details{
These methods (should) work as expected: an object of class
\code{free} is a list but standard extraction techniques should work.
}
\note{
  Extraction by \code{NA} is not implemented.
}
\examples{

(x <- rfree(20,8,8))

x[5:6]
x[1:2]  <- -x[11:12]

x[1:5] <- keep(x[1:5],1:3)

}

\name{size}
\alias{size}
\alias{total}
\alias{number}
\alias{bigness}
\title{Bignesses of a free object}
\description{Various metrics to describe how \dQuote{big} a free object is}
\usage{
size(a)
total(a)
number(a)
bigness(a)
}
\arguments{
  \item{a}{Vector of free group objects}
}
\details{

  \itemize{

    \item The \dfn{size} of an object is the number of pure powers in
    it (this is the number of columns of the matrix representation of
    the word)
    
    \item The \dfn{total} of an object is the sum of the absolute
    values of its powers
    
    \item The \dfn{number} of an object is the number of distinct symbols
    in it
  }
  
  Thus \code{size(a^2ba)=3}, \code{total(a^2ba)=4}, and
  \code{number(a^2ba)=2}.

  Function \code{bigness()} is a convenience wrapper that returns all
  three bigness measures.
    
}
\value{These functions return an integer vector.}
\author{Robin K. S. Hankin}
\note{
I would like to thank Murray Jorgensen for his insightful comments which
inspired this functionality.
}
\seealso{\code{\link{abs}}}
\examples{

(a <- rfree(20, 6, 4))
size(a)
total(a)
number(a)

a <- rfree(20, 6, 4)
b <- rfree(20, 6, 4)

## Following should all be TRUE
size(a+b)   <= size(a)  + size(b)
total(a+b)  <= total(a) + total(b)
number(a+b) <= number(a)+ number(b)

bigness(rfree(10, 3, 3))
bigness(allconj(rfree(1, 6, 1)))

}

\name{identity}
\alias{identity}
\alias{id}
\alias{is.id}
\alias{is.identity}
\alias{is.id.free}
\alias{neutral}
\title{The identity element}
\description{Create and test for the identity element}
\usage{
is.id(x)
id(n)
\method{is.id}{free}(x)
}
\arguments{
  \item{x}{Object of class \code{free}}
  \item{n}{Strictly positive integer}
}
\details{

Function \code{id()} returns a vector of \code{n} free objects, all of
which are the identity element.  Do not ask what happens if \eqn{n=0}.

Function \code{is.id()} returns a Boolean indicating whether an element
is the identity or not.  The identity can also be generated using
\code{as.free(0)}.

}
\author{Robin K. S. Hankin}
\examples{
id()
as.free(0)   # convenient R idiom for creating the identity

x <- rfree(10,3)
stopifnot(all(x == x + as.free(0)))
stopifnot(all(is.id(x-x)))

}

\name{abs.free}
\alias{abs.free}
\alias{abs}
\title{Absolute value of a \code{free} object}
\description{
  Replaces every term's power with its absolute value
}
\usage{
\method{abs}{free}(x)
}
\arguments{\item{x}{Object of class \code{free}}}
\details{
  Replaces every term's power with its absolute value
}

\author{Robin K. S. Hankin}
\note{

The function's name is motivated  by the inequality in the examples
section.

}

\seealso{\code{\link{subs}}}
\examples{

abs(abc(-5:5))

a <- rfree(10,4,7)
b <- rfree(10,4,7)

a
abs(a)

## following should all be TRUE:
all(size(abs(a+b))  <=  size(abs(a) + abs(b)))
all(total(abs(a+b)) <=  total(abs(a) + abs(b)))
all(number(abs(a+b)) <= number(abs(a) + abs(b)))

all(size(a+b)   <= size(abs(a) + abs(b)))
all(total(a+b)  <= total(abs(a) + abs(b)))
all(number(a+b) <= number(abs(a) + abs(b)))

}

\name{dot-class}
\docType{class}
\alias{dot}
\alias{.}
\alias{dot-class}
\alias{extract}
\alias{commutator}
\alias{jacobi}
\alias{dot_error}
\alias{[.dot}
\alias{[,dot-method}
\alias{[,dot,ANY,ANY-method}
\alias{[,dot,free,ANY,ANY-method}
\title{Class \dQuote{dot}}
\description{

  The dot object is defined in the \CRANpkg{freealg} package, and
  imported here, so that idiom like \code{.[x,y]} returns the
  commutator, that is, \code{x^-1 y^-1 xy}.

  The dot object is generated by running script \code{inst/dot.Rmd},
  which includes some further discussion and technical documentation,
  and creates file \code{dot.rda} which resides in the \code{data/}
  directory.

}
\usage{
\S4method{[}{dot,ANY,ANY}(x, i, j, drop)
\S4method{[}{dot,free,ANY,ANY}(x, i, j, drop)
}
\arguments{
  \item{x}{Object of any class}
  \item{i, j}{elements to commute}
  \item{drop}{Boolean, indicates whether to drop attributes}
}
\value{
  Always returns an object of the same class as \code{xy}.
}
\author{Robin K. S. Hankin}
\examples{

.[as.free("x"), as.free("y")]

.[abc(1:6), "z"]

x <- rfree()
y <- rfree()
z <- rfree()

.[x, y] == -x-y+x+y   # should be TRUE

abelianize(.[x, y])

## Jacobi identity _not_ satisfied with this definition:
is.id(.[x, .[y, z]] + .[y, .[z, x]] + .[z, .[x, y]])

## But the Hall-Witt identity is:
all(is.id(.[.[x, -y], z]^y + .[.[y, -z], x]^z + .[.[z, -x], y]^x))

}

\name{reduce}
\alias{reduce}
\alias{remove_zero_powers}
\alias{is_reduced}
\alias{consolidate}
\alias{is_proper}
\title{Reduction of a word to reduced form}
\description{Given a word, remove redundant zero-power terms, and
  consolidate adjacent like terms into a single power}
\usage{
reduce(a)
is_reduced(a)
remove_zero_powers(a)
consolidate(a)
is_proper(a)
}
\arguments{
  \item{a}{An object of class \code{free}}
}
\details{
  A word is \dfn{reduced} if no symbol appears next to its own inverse
  and no symbol has zero power.  The essence of the package is to reduce
  a word into a reduced form.  Thus \eqn{a^2b^{-1}ba}{a^2b^-1ba} will
  transformed into \eqn{a^3}.
  
  In the package, reduction happens automatically at creation, in
  function \code{free()}.

  Apart from \code{is_proper()}, the functions all take a \code{free}
  object, but the meat of the function operates on a single two-row
  matrix.

  Reduction is carried out by repeatedly consolidating adjacent terms of
  identical symbol (function \code{consolidate()}), and removing zero
  power terms (function \code{remove_zero_power()}) until the word is in
  reduced form (function \code{is_reduced()}).

  Function \code{is_proper()} checks to see whether a matrix is suitably
  formed for passing to \code{reduce()}.

  A \code{free} object is \dfn{cyclically reduced} iff every cyclic
  permutation of the word is reduced.  A reduced word is cyclically
  reduced iff the first letter is not the inverse of the last one.  A
  reduced word is cyclically reduced if the first and last symbol differ
  (irrespective of power) or, if identical, have powers of opposite
  sign.  For example, \code{abac} and \code{abca} are cyclically reduced
  but \code{abca^{-1}} is not.  Function \code{is.cyclically.reduced()}
  tests for this, documented at \code{cycred.Rd}.

}
\author{Robin K. S. Hankin}
\seealso{\code{\link{cycred}}}
\examples{

## create a matrix:
(M <- rbind(c(1,2,3,3,2,3,2,1),c(1,2,3,-3,5,0,7,0)))

## call the print method (note non-reduced form):
as.character_free(M)

## show the effect of reduce():
as.character_free(reduce(M))

## free() calls reduce() automatically:
free(M)
}

\name{Ops.free}
\alias{Ops.free}
\alias{ops}
\alias{free_equal}
\alias{free_power}
\alias{free_repeat}
\alias{juxtapose}
\alias{inverse}
\alias{inverse.free}
\alias{inverse.matrix}
\title{Arithmetic Ops methods for the free group}
\description{
  Allows arithmetic operators to be used for manipulation of free group elements
  such as addition, multiplication, powers, etc
}
\usage{
\method{Ops}{free}(e1, e2)
free_equal(e1,e2)
free_power(e1,e2)
free_repeat(e1,n)
juxtapose(e1,e2)
\method{inverse}{free}(e1)
\method{inverse}{matrix}(e1)
}
\arguments{
  \item{e1,e2}{Objects of class \code{free}}
  \item{n}{An integer, possibly non-positive}
}
\details{

  The function \code{Ops.free()} passes binary arithmetic operators
  (\dQuote{\code{+}}, \dQuote{\code{-}}, \dQuote{\code{*}},
  \dQuote{\code{^}}, and \dQuote{\code{==}}) to the appropriate
  specialist function.

  There are two non-trivial basic operations: juxtaposition, denoted
  \dQuote{\code{a+b}}, and inversion, denoted \dQuote{\code{-a}}.  Note
  that juxtaposition is noncommutative and \code{a+b} will not, in
  general, be equal to \code{b+a}.

  All operations return a reduced word.

  The caret, as in \code{a^b}, denotes group-theoretic exponentiation
  (\code{-b+a+b}); the notation is motivated by the identities
  \code{x^(yz) == (x^y)^z} and \code{(xy)^z == x^z * y^z}, as in the
  \code{permutations} package.

  \strong{As an experimental feature} the package now accepts
  multiplicative notation, so these identities manifest in package idiom
  as written.  However, this renders distributivity incorrect so that
  \code{x*(y + z)} and \code{x*y + x*z} are not equal, in general
  [distributivity manifests as \code{x*c(y, z) == c(x*y, x*z)}].

  Multiplication between a free object \code{a} and an integer \code{n}
  (as in \code{a*n} or \code{n*a}) is defined as juxtaposing \code{n}
  copies of \code{a} and reducing.  Zero and negative values of \code{n}
  work as expected.

  Comparing a \code{free} object with a numeric does not make sense and
  idiom such as \code{rfree() > 4} will return an error.  Comparing a
  \code{free} object with another \code{free} object might be desirable
  [specifically, lexicographic ordering], but is not currently
  implemented.

}
\author{Robin K. S. Hankin}
\note{
  The package uses additive notation but multiplicative notation might
  have been better.
}
\examples{


x <- as.free(c("a","ab","aaab","abacc"))
y <- as.free(c("aa","BA","Bab","aaaaa"))
x
y


x + x
x + y
x + as.free("xyz")

x+y == y+x    # not equal in  general

x*5 == x+x+x+x+x      # always true

x + alpha(26)

x^y
}

\name{free}
\alias{free}
\alias{free-class}
\alias{as.free}
\alias{is.free}
\alias{list_to_free}
\title{Objects of class \code{free}}
\description{Generate, and test for, objects of class \code{free}}
\usage{
free(x)
as.free(x)
is.free(x)
list_to_free(x)
}
\arguments{
  \item{x}{Function \code{free()} needs either a two-row matrix, or a
    list of two-row matrices; function \code{as.free()}
    attempts to coerce different types of argument before passing to
    \code{free()} (possibly via \code{list_to_free()})}
}
\details{
The basic structure of an element of the free group is a two-row matrix.
The top row is the symbols (1=a, 2=b, 3=c, etc) and the bottom row is
the corresponding power.  Thus \eqn{a^2ba^{-1}c^9}{a^2ba^-1c^9} would be

\preformatted{
> rbind(c(1,2,1,3),c(2,1,-1,9))
     [,1] [,2] [,3] [,4]
[1,]    1    2    1    3
[2,]    2    1   -1    9
>
}

Function \code{free()} needs either a two-row matrix or a list of
two-row matrices.  It is the only place in the package that sets the
class of an object to \code{free}.  Function \code{as.free()} is a bit
more user-friendly and tries a bit harder to do the Right Thing.

The package uses \code{setOldClass("free")} for the \code{dot} methods.

}
\author{Robin K. S. Hankin}
\seealso{\code{\link{char_to_free}}}
\examples{
free(rbind(1:5,5:1))

x <- rfree(10,3)
x
x+x
x-x
x[1:5]*(1:5)


as.free(c(4,3,2,2,2))
as.free("aaaabccccaaaaa")
as.free(c("a","A","abAAA"))
}

\name{subs}
\alias{subs}
\alias{subsu}
\alias{flip}
\title{Substitute and invert symbols}
\description{Substitute and invert specific symbols in a free object}
\usage{
subsu(X, from, to)
subs(X, ...)
flip(X, turn)
}
\arguments{
  \item{X}{Object of class \code{free}}
  \item{from,to,turn}{Objects coerced to class \code{free} specifying symbols
    to alter.  These arguments are coerced to symbols using
    \code{getlet(as.free())}}
  \item{...}{Named arguments for substitution}
}
\details{

  Function \code{subsu(X,from,to)} takes object \code{X} and transforms
  every symbol present in \code{from} into the symbol specified in
  \code{to}.

  Function \code{flip(X,turn)} takes object \code{X} and replaces every
  symbol present in \code{turn} with its inverse.

  Function \code{discard()}, documented at \code{keep.Rd}, effectively
  substitutes a symbol with the identity element (thereby discarding
  it).

  Experimental function \code{subs()} is modelled on similar
  functionality in the \CRANpkg{freealg} package and makes idiom such as
  \code{subs(X,a='z')} work as expected (viz, taking each instance of
  symbol \code{a} and replacing it with \code{x}).
  
}
\author{Robin K. S. Hankin}

\note{

  Functions \code{subs()} and \code{subsu()} substitute for particular
  symbols, not free group elements.  In particular, be careful with
  uppercase (inverse) symbols; because the power is discarded,
  substituting with \code{x} is the same as substituting for \code{X}.
  This behaviour might change in the future.
}

\seealso{\code{\link{abs}},\code{\link{discard}}}
\examples{

subsu(abc(1:10),abc(5),'z')
flip(abc(1:10),abc(5))


o <- rfree(30,5,10)

# Following tests should all be TRUE:
size(flip(o,'a'))   == size(o)
number(flip(o,'a')) == number(o)
total(flip(o,'a'))  == total(o)

size(subsu(o,'a','b'))   <= size(o)
number(subsu(o,'a','b')) <= number(o)
total(subsu(o,'a','b'))  <= total(o)


frog <- rfree()
subs(frog,a='x')

}

\name{nielsen}
\alias{nielsen}
\alias{outer}
\alias{automorphism}
\alias{automorphisms}
\alias{permsymb_single_X}
\alias{permsymb_single_f}
\alias{permsymb_vec}
\alias{permsymb}
\alias{autosub_lowlevel}
\alias{autosub}
\title{Outer automorphisms of the free group}
\description{Vectorized functionality to implement outer automorphisms
  of the free group}
\usage{
permsymb_single_X(X, f)
permsymb_single_f(X, f)
permsymb_vec(X, f)
permsymb(X, f)
autosub_lowlevel(M, e, S)
autosub(X, e, S, automorphism_warning=TRUE)
}
\arguments{
  \item{X, S}{Object of class \code{free}}
  \item{f}{Permutation function}
  \item{M}{Single free group element, in two-row matrix form}
  \item{e}{Single element to substitute}
  \item{automorphism_warning}{Boolean, with default \code{TRUE} meaning
    to give a warning if the requested substitution is not an
    automorphism and \code{FALSE} meaning not to give the warning}
}
\details{
In 1924, Nielsen showed that the automorphism group of the free group
with basis \eqn{[x_1,\ldots,x_n]}{[x_1,...,x_n]} is generated by the
following four elementary Nielsen transformations:

\enumerate{
  \item switch \eqn{x_1} and \eqn{x_2}
  \item Cyclically permute \eqn{x_1,x_2,\ldots,x_n}{x_1,x_2,...,x_n}
  to \eqn{x_2,\ldots,x_n,x_1}{x_2,...,x_n,x_1}
  \item Replace \eqn{x_1} with \eqn{x_1^{-1}}{x_1^-1}
  \item Replace \eqn{x_1} with \eqn{x_1x_2}{x_1 x_2}.
}

The functions documented here give vectorized methods to effect such
outer automorphisms, using the \CRANpkg{permutations} package.

Operations 1 and 2 above generate the symmetric group \eqn{S_n} and such
automorphisms are effected by function \code{permsymb()}.  Operation
3 is carried out by by \code{flip()} and operation 4 by \code{subsymb()}.

Functions \code{permsymb_single_X()}, \code{permsymb_single_f()},
\code{permsymb_vec()} and \code{subsymb_lowlevel()} are low-level helper
functions that are not really suited for the end user; use
\code{permsymb()}, \code{flip()} and \code{subsymb()} instead.

}
\references{
  Wikipedia contributors. (2018, October 29).  \dQuote{Automorphism
group of a free group}. In \emph{Wikipedia, The Free
Encyclopedia}. Retrieved 19:58, January 10, 2019, from
\url{https://en.wikipedia.org/w/index.php?title=Automorphism_group_of_a_free_group&oldid=866270661}
}
\author{Robin K. S. Hankin}
\seealso{\code{\link{flip}}}
\note{

  Function \code{permsymb()} is intended to work nicely with the
  \CRANpkg{permutations} package; see \code{inst/outer.Rmd} for some
  illustrations.  The function is not perfect. }

\examples{

P <- as.free(c("abc", "aba", "cc", "ca"))
autosub(P, "c", as.free("xyz"))

flip(P, "c")
flip(P, "ac")

}

\name{sum}
\alias{sum}
\alias{sum.free}
\alias{prodfree}
\alias{freeprod}
\title{Repeated summation by concatenation}
\description{
Concatenates its arguments to give a single free object
}
\usage{
\method{sum}{free}(..., na.rm = FALSE)
}
\arguments{
  \item{\dots}{Objects of class \code{free}, to be summed}
  \item{na.rm}{Boolean, indicating whether to ignore \code{NA} entries
    (currently ignored)}    
}
\details{
  Function \code{sum()} concatenates its arguments and gives a single
  element of the free group.  It works nicely with \code{rev()}, see the
  examples.  Note that \code{sum(x,y)} is not the same as \code{x+y}.
}
\author{Robin K. S. Hankin}
\note{
The package uses additive notation, but it is easy to forget this and
wonder why idiom like \code{prod(rfree())} does not work as desired.  Of
course, the package using additive notation means that one probably
wants \code{sum(rfree())}.
}
\examples{

(x <- rfree(10,3))
sum(x)
abelianize(sum(x))

(y <- rfree(10,6))

sum(x,y)
sum(x,y) == sum(sum(x),sum(y))
x+y  # not the same!

sum(x,-x)
sum(x,rev(-x))

z <- alpha(26)
stopifnot(sum(x^z) == sum(x)^z)

}

\name{cumsum}
\alias{cumsum}
\alias{cumsum.free}
\title{Cumulative sum}
\description{Cumulative sum of free vectors}
\usage{
\method{cumsum}{free}(x)
}
\arguments{
  \item{x}{Vector of class free}
}
\author{Robin K. S. Hankin}
\seealso{\code{\link{sum}}}
\examples{
abc(1:6)
cumsum(abc(1:6))

x <- rfree(10,2)
cumsum(c(x,-rev(x)))
}

\name{shift}
\alias{shift}
\title{Permute elements of a vector in a cycle}
\description{Given a vector, permute the elements with a cyclic permutation}
\usage{
shift(x,i=1)
}
\arguments{
  \item{x}{Vector}
  \item{i}{Integer, number of places to permute.  Negative values mean
    to count from the end}
}
\details{
This function is that of the \CRANpkg{magic} package, where it is
motivated and discussed.
}
\value{Returns a vector}
\author{Robin K. S. Hankin}
\examples{

shift(1:9)
shift(1:9,-1)

shift(1:9,2)


}

\name{rfree}
\alias{rfree}
\alias{rfreee}
\alias{rfreeee}
\title{Random free objects}
\description{Creates a vector of random free objects.  Intended as a
  quick \dQuote{get you going} example of free group objects}
\usage{
rfree(n = 7, size = 4, number = size, powers = seq(from = -size, to = size))
rfreee(n = 30, size = 8, number = size, powers = seq(from = -size, to = size))
rfreeee(n = 40, size = 25, number = size, powers = seq(from = -size, to = size))
}
\arguments{
  \item{n}{Length of random vector to generate}
  \item{size}{Maximum length of each element}
  \item{number}{How many distinct letters to sample from}
  \item{powers}{Powers in resulting polynomial.  An integer \code{n} is
    interpreted (via \code{sample()}) as \code{seq_len(n)}}
}
\details{
The auxiliary arguments specify the general complexity of the returned
object with small meaning simpler.

Functions \code{rfreee()} and \code{rfreeee()} give, by default,
successively more complicated expressions.

}
\author{Robin K. S. Hankin}
\seealso{\code{\link{size}}}
\examples{

rfree()

abelianize(rfree())

rfree(10,2)
rfree(10,30,26)

rfree(powers=5)
rfree(powers=5:6)

rfree(20,2)^alpha(26)

}

\name{keep}
\alias{keep}
\alias{discard}
\alias{drop}
\alias{retain}
\alias{drop.free}
\title{Keep or drop symbols}
\description{Keep or drop symbols}
\usage{
keep(a, yes)
discard(a, no)
}
\arguments{
  \item{a}{Object of class \code{free}}
  \item{yes,no}{Specification of symbols to either keep (yes) or discard 
    (no), coerced to a free object}
}
\author{Robin K. S. Hankin}
\note{
  Function \code{keep()} needs an explicit \code{return()} to prevent it
  from returning invisibly.

  The functions are vectorised in the first argument but not the
  second.

  The second argument---the symbols to keep or discard---is formally a
  vector of nonnegative integers, but the functions coerce it to a free
  object.  The symbols kept or dropped are the union of the symbols in
  the elements of the vector.  Function \code{discard()} was formerly
  known as \code{drop()} but this conflicted with \code{base::drop()}.

  These functions have nothing in common with APL's \code{take()} and
  \code{drop()}.

}
\examples{
(x <- rfree(20,5,8))

keep(x,abc(4))           # keep only symbols a,b,c,d
discard(x,as.free('cde'))   # drop symbols c,d,e

keep(x,alpha(3))  # keep only abc 

}

\name{getlet}
\alias{getlet}
\title{Get letters of a freegroup object}
\description{Get the symbols in a freegroup object}
\usage{
getlet(x)
}
\arguments{
  \item{x}{Object of class \code{free}}
}
\author{Robin K. S. Hankin}
\note{
  By default, return a list with elements corresponding to the elements
  of \code{x}.  But, if object \code{x} is of length 1, a vector is
  returned.  The result is sorted for convenience.
}
\examples{

(x <- rfree(6,7,3))

getlet(x)

as.free(getlet(x))  

identical(as.free(getlet(abc(1:26))), abc(1:26))

}

\name{char_to_free}
\alias{char_to_free}
\alias{char_to_matrix}
\title{Convert character vectors to free objects}
\description{Convert character vectors to free objects}
\usage{char_to_matrix(x)}
\arguments{
  \item{x}{A character vector}
}
\details{
  Function \code{char_to_matrix()} gives very basic conversion between
  character vectors and free objects.  Current functionality is limited
  to strings like \dQuote{\code{aaabaacd}}, which would give
  \eqn{a^3ba^2cd}{a^3.b.a^2.c.d}.  It would be nice to take a string
  like \dQuote{\code{a^3b^(-3)}} but this is not yet implemented.

  Function \code{char_to_free()} is a vectorized version that coerces
  output to \code{free}.

}
\note{
  
  The function is not particularly robust; for example, passing anything
  other than letters a-z or A-Z will give possibly undesirable
  behaviour.

  Upper-case letters A-Z are interpreted by \code{char_to_matrix()} as
  the inverse of their corresponding lower-case equivalents.  This
  behaviour is inherited by \code{char_to_free()} and \code{as.free()},
  so that \code{as.free("A") == inverse(as.free("a"))}.
  
  Function \code{char_to_free()} is consistent with the default print
  options (which are that the symbols are the lowercase letters a-z).
  If you change the symbols' names, for example
  \code{options(freegroup_symbols=sample(letters))}, then things can get
  confusing.  The print method does not change the internal
  representation of a \code{free} object, which is a list of integer
  matrices.
}

\author{Robin K. S. Hankin}
\seealso{\code{\link{print.free}}}
\examples{

char_to_matrix("aaabcABC")

rfree(10,3) + as.free('xxxxxxxxxxxx')

as.free(letters)*7

all(is.id(as.free(letters) + as.free(LETTERS)))


as.free('')  # identity element

}

\name{primitive}
\alias{primitive}
\alias{is.primitive}
\alias{is.power}
\title{Primitive elements of the free algebra}
\description{

  A \dfn{primitive word} is one that is not of the form \code{a^m} for
  any \eqn{m>1}.  The concept is used in Lyndon and Schutzenberger 1962.
  
}
\usage{
is.primitive(x)
is.power(d,n)
}
\arguments{
  \item{x}{Freegroup object, coerced to Tietze form}
  \item{d}{Numeric vector}
  \item{n}{Integer}
}
\details{

Function \code{is.primitive()} returns a boolean vector indicating
whether the elements of its argument are primitive.

Function \code{is.power()} is a lower-level helper function.
\code{is.power(d,n)} determines whether \code{d} is an \code{n}-th power
(that is, \code{d} may be written as \code{n} copies of some numeric
vector).

Thus \code{is_power(c(4,5,7,4,5,7,4,5,7,4,5,7),4)} returns \code{TRUE}
because its primary argument is indeed a fourth power (of
\code{c(4,5,7)}).


}
\value{
Returns a boolean.
}
\references{

R. C. Lyndon and M. P. Schutzenberger 1962.  \dQuote{The equation
  \eqn{a^M=b^Nc^P} in a free group}.  Michigan Mathematical Journal,
  9(4): 289--298.

}
\author{
  Robin K. S. Hankin.  The code for finding the factors of an integer
  was (somewhat more than) inspired by the \CRANpkg{numbers} package.
}
\examples{

is.primitive(as.free(c("a","aaaa", "aaaab", "aabaab", "aabcaabcaabcaabc")))

is.power(c(7,8,4,7,8,4,7,8,4,7,8,4),4)


table(is.primitive(rfree(100)))


## primitive with >1 symbols is rare:
x <- rfree(1000)
x[!is.primitive(x) & number(x)>1]
##  try x <- rfree(10000) [but this takes a long time]


}

\name{freegroup-package}
\alias{freegroup-package}
\alias{freegroup}
\docType{package}
\title{
\packageTitle{freegroup}
}
\description{
\packageDescription{freegroup}
}
\details{

The DESCRIPTION file:
\packageDESCRIPTION{freegroup}
\packageIndices{freegroup}

}
\author{
\packageAuthor{freegroup}

Maintainer: \packageMaintainer{freegroup}
}
\keyword{ package }
\examples{
p <- rfree(10,6,3)
x <- as.free('x')

p+x

p^x

sum(p)

abelianize(p)

subsu(p,"ab","z")
subs(p,a='z')


discard(p+x,'a')

}

\name{abelianize}
\alias{abelianize}
\alias{abelianized}
\alias{is.abelian}
\title{Abelianization of free group elements}
\description{Function \code{abelianize()} returns a word that is
equivalent to its argument under assumption of Abelianness.  The symbols
are placed in alphabetical order.}
\usage{
  abelianize(x)
  is.abelian(x)
}
\arguments{
  \item{x}{An object of class \code{free}}
}
\details{
Abelianizing a free group element means that the symbols can commute
past one another.  Abelianization is vectorized.

Function \code{is.abelian()} is trivial: it just checks to see whether
argument \code{x} has its symbols in alphabetical order.  It might have
been better to call this \code{abelianized()}.

Package \CRANpkg{frab} presents extensive R-centric functionality for
dealing with the free Abelian group.  It is much more efficient than
this package for Abelian operations, and contains bespoke methods for
working with a range of applications such as tables of counts.

}
\author{Robin K. S. Hankin}
\examples{

x <- as.free("aabAA")
x
abelianize(x)

x <- rfree(10,10,2)
x
abelianize(x)

abelianize(.[rfree(),rfree()])


p <- free(rbind(rep(1:5,4),rep(1:4,5)))
p
abelianize(p)
}

\name{print}
\alias{print.free}
\alias{print.freegroup}
\alias{as.character_free}
\title{Print free objects}
\description{Print methods for free objects}
\usage{
\method{print}{free}(x,...)
as.character_free(m,latex=getOption("latex"))
}
\arguments{
  \item{x}{Object of class \code{free} in the print method}
  \item{m}{A two-row matrix in function \code{as.character_free()}}
  \item{latex}{Boolean, with \code{TRUE} meaning to print latex-friendly
    output including curly braces, and default \code{NULL} option
    meaning to give a nicer-looking output that latex would typeset
    incorrectly}
  \item{...}{Further arguments, currently ignored}
}
\author{Robin K. S. Hankin}
\note{
The print method does not change the internal representation of a
\code{free} object, which is a list of integer matrices.

The default print method uses multiplicative notation (powers) which is
inconsistent with the juxtaposition method \dQuote{\code{+}}.

The print method has special dispensation for length-zero free objects
but these are not handled entirely consistently.

The default print method uses lowercase letters a-z, but it is possible
to override this using \code{options("freegroup_symbols" = foo)}, where
\code{foo} is a character vector.  This is desirable if you have more
than 26 symbols, because unallocated symbols appear as \code{NA}.

The package will allow the user to set
\code{options("freegroup_symbols")} to unhelpful things like
\code{rep("a",20)} without complaining (but don't actually do it, you
crazy fool).

}
\seealso{\code{\link{char_to_free}}}  
\examples{

## default symbols:

abc(26)
rfree(1,10)


# if we need more than 26:
options(freegroup_symbols=state.name)
rfree(10,4)

# or even:
jj <- letters[1:10]
options(freegroup_symbols=apply(expand.grid(jj,jj),1,paste,collapse=""))
rfree(10,10,100,4)

options(freegroup_symbols=NULL)  #  NULL is interpreted as letters a-z
rfree(10,4)            #  back to normal
}

\name{backwards}
\alias{backwards}
\title{Write free objects backwards}
\description{Write free objects in reverse order}
\usage{
backwards(x)
}
\arguments{
  \item{x}{Object of class \code{free}}
}
\author{Robin K. S. Hankin}
\note{

  For each element of a \code{free} object, function \code{backwards()}
  writes the symbols in reverse order.  It is distinct from
  \code{rev()}, see examples.

  Function backwards is an involution: it is its own inverse.

}
\examples{
abc(1:5)
backwards(abc(1:5))
rev(abc(1:5))

x <- rfree(10,5)
backwards(backwards(x)) == x  # involution
all(abelianize(x) == abelianize(backwards(x))) # should be TRUE
}

\name{tietze}
\alias{tietze}
\alias{Tietze}
\alias{tietze.matrix}
\alias{tietze.free}
\alias{vec_to_matrix}
\title{Tietze form for free group objects}
\description{Translate an object of class \code{free} to and from Tietze form}
\usage{
\method{tietze}{free}(x)
\method{tietze}{matrix}(x)
vec_to_matrix(x)
}
\arguments{
  \item{x}{Object to be converted}
}
\details{

  The Tietze form for a word is a list of integers corresponding to the
  symbols of the word; typically \eqn{a=1,b=2,c=3,d=4}, etc.  Negative
  integers represent the inverses of the symbols.  Thus
  \code{c^4.d^-2.a.c} becomes \code{3 3 3 3 -4 -4 1 3}.
  
  Function \code{vec_to_matrix()} is a low-level helper function that
  returns a two-row integer matrix.  If given \code{0} or \code{NULL},
  it returns a two-row, zero-column matrix.
}

\author{Robin K. S. Hankin}
\examples{

(x <- rfree(10,3))
tietze(x)

vec_to_matrix(c(1,3,-1,-1,-1,2))

as.free(list(c(1,1,8),c(2,-4,-4)))

all(as.free(tietze(abc(1:30))) == abc(1:30))

}

\name{donames}
\alias{donames}
\alias{names}
\title{Names attributes of free group elements}
\description{Get and set names of free group elements and arithmetic operations}
\usage{
donames(f,e1,e2)
}
\arguments{
  \item{f}{A vector, typically of class \code{free}}
  \item{e1,e2}{Objects of class \code{free}, possibly with names}
}
\details{

  Function \code{donames()} is a low-level helper function that ensures
  that the result of arithmetic operations such as \code{+} and \code{^}
  have the correct names attributes.  The behaviour is inherited from
  that of \code{base::`+`}.
  
}
\author{Robin K. S. Hankin}
\seealso{\code{\link{Ops.free}}}
\examples{

x <- rfree(9,4)
x
names(x) <- letters[1:9]
x

z <- as.free('z')
x + x 
x^z
z^x

n <- 1:9
names(n) <- LETTERS[1:9]

x*n
n*x  # note different names 


}

\name{c}
\alias{c}
\alias{c.free}
\alias{c}
\alias{rep.free}
\title{Concatenation of free objects}
\description{Concatenate free objects together}
\usage{
\method{c}{free}(...)
\method{rep}{free}(x, ...)
}
\arguments{
  \item{\dots}{In the method for \code{c()}, objects to be
    concatenated.  Should all be of the same type}
  \item{x}{In the method for \code{rep()}, a free object}
}
\author{
Robin K. S. Hankin
}

\examples{
(x <- abc(1:3))
(y <- alpha(22:25))

c(x, y, x, x)


## NB: compare
rep(x, 2)  
x*2  
}

\name{alpha}
\alias{alpha}
\alias{abc}
\alias{alphabet}
\title{Alphabetical free group elements}
\description{Produces simple vectors of free group elements based on the
  alphabet}
\usage{
alpha(v)
abc(v)
}
\arguments{
  \item{v}{Vector of integers}
}
\details{

  Function \code{alpha()} takes an integer \code{i} and returns the
  letter \code{i} of the alphabet.  Thus \code{alpha(3)} returns
  \code{c}.  The function is vectorised: \code{alpha(1:3)} returns
  \code{a b c}.

  Function \code{abc()} takes an integer \code{i} and returns letters
  1 to \code{i} of the alphabet.  Thus \code{abc(4)} returns
  \code{a.b.c.d}.  The function is vectorised.

  Remember that \dQuote{letters of the alphabet} is just a phrase:
  above it refers to the default print method which can be changed,
  see the examples.

}
\author{Robin K. S. Hankin}
\examples{
alpha(5)  # just the single letter 'e'
abc(5)    # product of a,b,c,d,e

alpha(1:26)  # the whole alphabet; c

all(alpha(1:26) == as.free(letters))  # should be TRUE

z <- alpha(26)  # variable 'z' is symbol 26, aka 'z'.
abc(1:10) ^ z

abc(-5:5)
alpha(-5:5)
sum(abc(-5:5))


## bear in mind that the symbols used are purely for the print method:
jj <- LETTERS[1:10]
options(freegroup_symbols = apply(expand.grid(jj,jj),1,paste,collapse=""))
alpha(c(66,67,68,69))   # sensible output
options(freegroup_symbols=NULL)   # restore to symbols to default letters
alpha(c(66,67,68,69))   # print method not very helpful now
}

\name{cycred}
\alias{cycred}
\alias{cyclic}
\alias{cyclically}
\alias{cyclically_reduced}
\alias{cyclically_reduce}
\alias{cyclic_reduction}
\alias{is.cyclically.reduced}
\alias{as.cyclically_reduced}
\alias{is.cyclically_reduced}
\alias{cyclically_reduce_tietze}
\alias{is.conjugate_single}
\alias{conjugate}
\alias{is.conjugate}
\alias{is.conjugate.free}
\alias{\%~\%}
\alias{allconj}
\title{Cyclic reductions of a word}
\description{Functionality to cyclically reduce words and detect conjugacy}
\usage{
is.cyclically_reduced(a)
as.cyclically_reduced(a)
cyclically_reduce(a)
cyclically_reduce_tietze(p)
is.conjugate_single(u,v)
x \%~\% y
\method{is.conjugate}{free}(x,y)
allconj(x)
}
\arguments{
  \item{a,x,y}{An object of class \code{free}}
  \item{p,u,v}{Integer vector corresponding to Tietze form of a word}
}
\details{

  A \code{free} object is \dfn{cyclically reduced} iff every cyclic
  permutation of the word is reduced.  A reduced word is cyclically
  reduced iff the first letter is not the inverse of the last one.  A
  reduced word is cyclically reduced if the first and last symbol differ
  (irrespective of power) or, if identical, have powers of opposite
  sign.  For example, \code{abac} and \code{abca} are cyclically reduced
  but \code{abca^{-1}} is not.  Function \code{is.cyclically_reduced()}
  tests for this.  

  Function \code{as.cyclically_reduced()} takes a vector of free objects
  and returns the elementwise cyclically reduced equivalents.  Function
  \code{cyclically_reduce()} is a synonym with better (English) grammar.

  The identity is cyclically reduced: it cannot be shortened by a
  combination of cyclic permutation followed by reduction.  This ensures
  that \code{is.cyclically_reduced(as.cyclically_reduced(x))} is always
  TRUE.  Also, it is clear that the identity should be conjugate to
  itself.

  Two words \eqn{a,b} are \dfn{conjugate} if there exists \eqn{x} such
  that \eqn{ax=xb} (or equivalently \eqn{a=x^{-1}bx}{a=x^-1 b x}).  This
  is detected by function \code{is.conjugate()}.  Functions
  \code{is_conjugate_single()} and \code{cyclically_reduce_tietze()} are
  lower-level helper functions.

  Function \code{allconj()} returns all cyclically reduced words
  conjugate to its argument.
    
}
\author{Robin K. S. Hankin}
\seealso{\code{\link{reduce}}}
\examples{

(x <- abc(1:9) - abc(9:1))
as.cyclically_reduced(x)

 a <- rfree(1000,3)
 all(size(as.cyclically_reduced(a)) <= size(a))
 all(total(as.cyclically_reduced(a)) <= total(a))
 all(number(as.cyclically_reduced(a)) <= number(a))



 x <- rfree(1000,2)
 y <- as.free('ab')
 table(conjugate = (x\%~\%y), equal = (x==y))  # note zero at top right

 allconj(as.free('aaaaab'))
 allconj(sum(abc(seq_len(3))))



 x <- rfree(1,10,8,8)
 all(is.id(allconj(x) + allconj(-x)[shift(rev(seq_len(total(x))))]))



}
